#=======================================================================
# this is where everything that is site-specific get defined
#=======================================================================

package AbsenceConfig;

BEGIN {
	#-------------------------------------------------------------
	# DATA and CGI directories
	# ACHTUNG.  You will probably want to set these
	#-------------------------------------------------------------

	# the following variables are declared for convenience
	$data_dir_rel	= '/absence';					# as used in a webpage
	$data_dir_abs	= "$ENV{DOCUMENT_ROOT}$data_dir_rel";	# as used by Perl
	$cgi_dir_rel	= "/cgi-bin";

	%VARS = (
		data_dir_rel	=> $data_dir_rel,
		data_dir_abs	=> $data_dir_abs,
		cgi_dir_rel		=> $cgi_dir_rel,

		#-------------------------------------------------------------
		# where are the images kept.  Probably OK as is.
		#-------------------------------------------------------------

		image_dir_rel	=> "$data_dir_rel/img",
		image_dir_abs	=> "$data_dir_abs/img",

		#-------------------------------------------------------------
		# where is absence database.  Probably OK as is.
		#-------------------------------------------------------------

		database_file	=> "$data_dir_abs/absence.db",

		#-------------------------------------------------------------
		# where is modification time db.  Probably OK as is.
		#-------------------------------------------------------------

		modtime_db_file	=> "$data_dir_abs/month_mod_times.db",

		#-------------------------------------------------------------
		# where is holiday.db file
		#-------------------------------------------------------------

		holiday_db_file	=> "$data_dir_abs/holiday.db",

		#-------------------------------------------------------------
		# where is log file.  Probably OK as is.
		#-------------------------------------------------------------

		log_file		=> "$data_dir_abs/log",

		#-------------------------------------------------------------
		# where is type file.  Probably OK as is.
		#-------------------------------------------------------------

		type_file		=> "$data_dir_abs/absence-types.db",

		#-------------------------------------------------------------
		# paths to various CGI-scripts
		#-------------------------------------------------------------

		main_script		=> "$cgi_dir_rel/absence.pl",
		manage_script	=> "$cgi_dir_rel/absence-manage.pl",
		control_script	=> "$cgi_dir_rel/absence-control.pl",

		#-------------------------------------------------------------
		# legend-style.  can either be "constant:<num>" or "fit"
		# if set to constant, all legend-labels will be <num> pixels wide
		# if "fit" labels will be fit to text
		#-------------------------------------------------------------

		#legend_style	=> 'constant:60',
		legend_style	=> 'fit',

		#-------------------------------------------------------------
		# the number of backup copies of the dababase file.
		# a new copy is made each time the database is modified
		#-------------------------------------------------------------

		backup_copies	=> 10,

		#-------------------------------------------------------------
		# select the image-type, png, jpg, or gif.  'gif' is only
		# supported on ancient versions of gd.  'png' is probably
		# the best choice if you have it.
		#-------------------------------------------------------------
		image_type		=> 'png',	# one of 'png', 'jpg', or 'gif'
	);
}

sub fetch
{
	my $val = shift;

	if (exists($VARS{$val})) {
		return $VARS{$val};
	}

	return undef;
}

1;
