package AbsenceLog;

use Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(abslog);

use Fcntl (':flock'); # import LOCK_* constants
use FileHandle;

use AbsenceConfig;

BEGIN {
	$LOGFILE	= AbsenceConfig::fetch('log_file');
	$IPADDR		= $ENV{'REMOTE_ADDR'};
}

sub SEEK_END() { 2; }	# not portable, but what the hell

sub abslog
{
	my $msg = shift;

	my $ts = timestamp();

	my $openstr = "+<$LOGFILE";

	if (! -e $LOGFILE) {
		$openstr = ">$LOGFILE";
	}

	my $fh = FileHandle->new($openstr);
	defined($fh) || die "open of [$LOGFILE] failed";
	flock($fh, LOCK_EX) || die "flock lock_ex on $LOGFILE ($!)";
	# position file-pointer at EOF
	seek($fh, 0, SEEK_END);
	if (ref($msg)) {
		print $fh "[$ts / $IPADDR]\n";
		foreach (@$msg) {
			print $fh "\t$_\n";
		}
	} else {
		print $fh "[$ts / $IPADDR] $msg\n";
	}
	flock($fh, LOCK_UN) || die "flock lock_un on $LOGFILE ($!)";
	$fh->close;
}

sub timestamp
{
	my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
	my ($sec,$min,$hour,$mday,$mon,$year,@junk) = localtime(time);

	return sprintf("%d-%s-%d %02d:%02d:%02d",
		$mday, $months[$mon], $year+1900, $hour, $min, $sec);
}

1;
